/*****************************************************
*   i2c    MSSP
* ----------------------------------------------------
* :  
* : 04.09.2002
* www.alex-uc.narod.ru
* sanya_z@rambler.ru
*****************************************************/


				#include	<pic.h>  
				#include	"i2c_mssp.h"

#ifdef _PIC18_H
	#define SSP_CON1	SSPCON1
#endif

#ifdef _PIC_H
	#define SSP_CON1	SSPCON
#endif

unsigned char i2c_error=0;

void
send_start(void)
{
	BCLIF=0;
	SSPIF=0;
	SEN=1;
	while (!SSPIF && !BCLIF);
	
	if (BCLIF) i2c_error=1; 
}

void
send_repeat_start()
{
	BCLIF=0;
	SSPIF=0;
	RSEN=1;
	while (!SSPIF && !BCLIF);
	if (BCLIF) i2c_error=1;
}


void
send_stop()
{
	BCLIF=0;
	SSPIF=0;
	PEN=1;
	while (!SSPIF && !BCLIF);
	if (BCLIF) i2c_error=1;
}

unsigned char
send_byte(unsigned char byte_data)
{
	BCLIF=0;
	SSPIF=0;
	SSPBUF=byte_data;
	while (!SSPIF && !BCLIF);
	if (BCLIF) i2c_error=1;
	if (ACKSTAT) return 1;
	return 0;
}

unsigned char
read_byte(unsigned char ack_bit)
{
	unsigned char data_byte;
	BCLIF=0;
	SSPIF=0;
	RCEN=1; 
	while (!SSPIF && !BCLIF);
	if (BCLIF) i2c_error=1;
	data_byte = SSPBUF;
	ACKDT=ack_bit;
	BCLIF=0;
	SSPIF=0;
	ACKEN=1;
	while (!SSPIF && !BCLIF);
	if (BCLIF) i2c_error=1;
	return data_byte;	
}

// -----------------------------------------
void
i2c_init()
{
	//  ""  i2c
	// -------------------------------
	SSP_CON1 = 0b00100010;
	
	RC3=0;
	TRISC3=0;

	SSPIF=0;
	SSPBUF=0xFF;
 	while (!SSPIF);

	SSPIF=0;
	SSPBUF=0xFF;
	while (!SSPIF);

	TRISC3=1;
	// -------------------------------

	SSP_CON1 = 0b00000000;

	SSPADD = (1000 * DEVICE_FOSC) / (4 * I2C_SPEED) - 1;
	SSP_CON1 = 0b00101000;
	SSPSTAT = 0b10000000;

}



unsigned char
i2c_test(unsigned char adr_device)
{
	unsigned char temp_i2c;
	send_start();
	temp_i2c = send_byte(adr_device & 0xFE);
	send_stop();
	return temp_i2c;	
}

void
i2c_wr (unsigned char adr_device, unsigned int adr_word, unsigned char flag_adr_int, unsigned char * data, unsigned char byte)
{
	unsigned char temp_i2c;
	send_start();
	temp_i2c = send_byte (adr_device & 0xFE);
	
	if (flag_adr_int) temp_i2c = send_byte ((adr_word >> 8) & 0xFF);
	temp_i2c = send_byte (adr_word & 0xFF);
	
	while (byte) {
		temp_i2c = send_byte (*data++);
		--byte;
	}
	
	send_stop();
}

void
i2c_rd (unsigned char adr_device, unsigned int adr_word, unsigned char flag_adr_int, unsigned char * data, unsigned char byte)
{
	unsigned char temp_i2c;
	send_start();
	temp_i2c = send_byte (adr_device & 0xFE);
	
	if (flag_adr_int) temp_i2c = send_byte ((adr_word >> 8) & 0xFF);
	temp_i2c = send_byte (adr_word & 0xFF);

	send_repeat_start();
	
	temp_i2c = send_byte (adr_device | 0x01);
	
	while (byte) {
		if (byte==1) temp_i2c=1;
		else temp_i2c=0;
		*data = read_byte (temp_i2c);
		++data;
		--byte;
	}
	
	send_stop();
}


